-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
M.type = "auxilliary"
M.gearboxInfo = {isReverse = false}
M.brake = 0
M.parkingbrake = 0
M.relevantDevice = nil 
M.clutchRatio = 0


local fl = 0
local gr = 0
local cn = 0
local throttle = 0
local prop = 0


local min = math.min
local max = math.max

local time = 0
local frequency = 0.5  -- Oscillations per second
local amplitude = 0.3  -- Peak value of the oscillation
local offset = 0     -- Value around which the oscillation occurs

local function onReset()
    fl = 0
    gr = 0
    cn = 0
    electrics.values.flap = fl
    electrics.values.can = cn
    electrics.values.landing = gr
    electrics.values.throttleup = 0
    electrics.values.throttledown = 0
    electrics.values.throttlespit = 0
    electrics.values.propup = 0
    electrics.values.propdown = 0
    electrics.values.propspit = 0
    electrics.values.prop_blur = 0
 
end


local function flap(VALUE)
    if VALUE == 1 then
        fl = 1 - fl
        electrics.values.flap = fl
       
    end
end

local function can(VALUE)
    if VALUE == 1 then
        cn = 1 - cn
        electrics.values.can = cn
    end
end

local function landing(VALUE)
    if VALUE == 1 then
        gr = 1 - gr
        electrics.values.landing = gr
    end
end



local function updateGFX(dt)

     --print (electrics.values["rpm"])
    
     if electrics.values["rpm"] > 1400 then
        --print (electrics.values["rpm"])
        electrics.values.prop_blur = 1
            
        else
        electrics.values.prop_blur = 0
    
    end

    
    time = time + dt
    
    local throttle = electrics.values.throttlespit or 0

    throttle = min(max(throttle + (electrics.values.throttleup * dt * 0.25) - (electrics.values.throttledown * dt * 0.25), 0), 1)
    electrics.values.throttle = throttle

    electrics.values.throttlespit = throttle

    local collective = electrics.values.propspit or 0

    prop = min(max(prop + (electrics.values.propup * dt * 0.25) - (electrics.values.propdown * dt * 0.25), 0), 1)
    electrics.values.prop = prop

    electrics.values.propspit = prop


    electrics.values.clutch = 0
    electrics.values.clutchRatio = 1
    
end






M.onInit    = onReset
M.onReset   = onReset
M.flap     = flap
M.can       = can
M.landing   = landing
M.updateGFX = updateGFX


return M